ALTER TABLE REZERVAC_DETAIL
ADD TIME_FROM DATE;

ALTER TABLE REZERVAC_DETAIL
ADD TIME_TO DATE;

ALTER TABLE REZERVAC_DETAIL
MODIFY USER_KREIRANJA VARCHAR2(250 CHAR);

INSERT INTO FILE_DATA(ID_FILE_DATA, FILE_ID, NAME, EXTENSION, DATA, DATE_CREATED, USER_CREATED, TYPE, ACT)
SELECT FILE_DATA_SEQ.NEXTVAL, 'PORTALMOBILE_LOGO', SUBSTR(IME_DATOTEKE, 1, INSTR(IME_DATOTEKE, '.', -1 ) - 1), UPPER(SUBSTR(IME_DATOTEKE, INSTR(IME_DATOTEKE, '.', -1 ) + 1)), DOKUMENT, SYSDATE, 'INFO', 'PML', 'Y'
FROM UPLOAD_DATA WHERE SIFRA = 'MARINA_MASTER_PORTALMOBILE_LOGO' AND NOT EXISTS (SELECT * FROM FILE_DATA WHERE FILE_ID = 'PORTALMOBILE_LOGO' AND ACT = 'Y');

DROP VIEW V_REZERVAC;

CREATE OR REPLACE VIEW V_REZERVAC AS (
SELECT R.ID AS ID_REZERVAC, D.ID_REZERVAC_DETAIL, R.ID_POGODBE, D.DATUM_OD AS RD_DATE_FROM, D.DATUM_DO AS RD_DATE_TO, D.TIME_FROM AS RD_TIME_FROM, D.TIME_TO AS RD_TIME_TO,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.OBJEKT FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.OBJEKT END) AS RD_OBJEKT, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.N_PRIVEZA FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.N_PRIVEZA END) AS RD_N_PRIVEZA,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.ID_PRIVEZ FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.ID_PRIVEZ END) AS RD_ID_PRIVEZ,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.NAME_PLACING FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.NAME_PLACING END) AS RD_NAME_PLACING,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.BOAT_GROUP_PLACING FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.BOAT_GROUP_PLACING END) AS RD_BOAT_GROUP_PLACING,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.BOAT_PLACING FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.BOAT_PLACING END) AS RD_BOAT_PLACING,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.OCCUPANCY_STATISTICS FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.OCCUPANCY_STATISTICS END) AS RD_OCCUPANCY_STATISTICS,
R.VRSTA, D.STATUS_REZERVAC AS RD_STATUS_REZERVAC, D.COMPLETE AS RD_COMPLETE, D.VRSTA AS RD_VRSTA, R.ID_LASTNIKA, R.ID_PLOVILA, R.OWNER_NOTIFIED,
R.DATUM_KREIRANJA AS R_DATUM_KREIRANJA, R.USER_KREIRANJA AS R_USER_KREIRANJA, R.DATUM_SPREMEMBE AS R_DATUM_SPREMEMBE, R.USER_SPREMEMBE AS R_USER_SPREMEMBE,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN 'EXIT' ELSE NNO.OBJECT_TYPE END) AS OBJECT_TYPE,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT OBLIKA FROM NNOBJEKT WHERE OBJECT_TYPE = 'EXIT') ELSE NNO.OBLIKA END) AS NNOBJEKT_OBLIKA,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT CENTER_POZICIJA_PLOVILA FROM NNOBJEKT WHERE OBJECT_TYPE = 'EXIT') ELSE NNO.CENTER_POZICIJA_PLOVILA END) AS CENTER_POZICIJA_PLOVILA,
POGNP.OBJEKT AS POGODBA_OBJEKT, POGNP.N_PRIVEZA AS POGODBA_N_PRIVEZA, R.DATUM_REZERVACIJE AS R_DATE_FROM, R.DATUM_DO AS R_DATE_TO, R.TIME_FROM AS R_TIME_FROM, R.TIME_TO AS R_TIME_TO,
RNP.OBJEKT AS R_OBJEKT, RNP.N_PRIVEZA AS R_N_PRIVEZA, RNP.ID_PRIVEZ AS R_ID_PRIVEZ, R.STATUS_REZERVAC AS R_STATUS_REZERVAC,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.DOLZINA FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.DOLZINA END) AS DOLZINA_PRIVEZA, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.SIRINA FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.SIRINA END) AS SIRINA_PRIVEZA, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.TRANS_X FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.TRANS_X END) AS TRANS_X_PRIVEZA, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.TRANS_Y FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.TRANS_Y END) AS TRANS_Y_PRIVEZA, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.ROT_DEGREES FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.ROT_DEGREES END) AS ROT_DEGREES_PRIVEZA, 
(CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.TRANS_X END) AS TRANS_X_PLOVILA, (CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.TRANS_Y END) AS TRANS_Y_PLOVILA, (CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.ROT_DEGREES END) AS ROT_DEGREES_PLOVILA, 
R.KOMENTAR, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.INT_CODE AS KUPCI_INT_CODE, RNNLOC.ID AS R_ID_LOCATION, RDNNLOC.ID AS RD_ID_LOCATION,
(SELECT COUNT(*) FROM M_DE_NA WHERE ID_PLOVILA = R.ID_PLOVILA AND (NNLOCATION_ID IS NULL OR NNLOCATION_ID = RDNNLOC.ID) AND UPPER(STATUS) = 'O') AS BOAT_OPEN_WO_NUMBER, 
(SELECT COUNT(*) FROM M_STORITVE WHERE ID_PLOVILA = R.ID_PLOVILA AND (NNLOCATION_ID IS NULL OR NNLOCATION_ID = RDNNLOC.ID) AND UPPER(VRSTA) IN ('PO', 'ST') AND N_RACUNA IS NULL) AS BOAT_OPEN_SERVICES_NUMBER,
RPD.ID_REZERVAC_PERIOD AS ID_REZERVAC_PERIOD, RVR.ACTIVE_LAST_DAY,
(CASE WHEN (SELECT COUNT(ID_CONTRACT_BERTH) FROM CONTRACT_BERTH CB WHERE CB.ID_POGODBE = R.ID_POGODBE AND CB.ID_PRIVEZ = D.ID_PRIVEZ) > 0 THEN 'Y' ELSE 'N' END) AS RD_CONTRACT_BERTH,
(CASE WHEN (SELECT COUNT(ID_CONTRACT_BERTH) FROM CONTRACT_BERTH CB LEFT OUTER JOIN V_PRIVEZ_LOCATION PRIV_LOCATION ON CB.ID_PRIVEZ = PRIV_LOCATION.ID_PRIVEZ WHERE CB.ID_POGODBE = R.ID_POGODBE AND NVL(PRIV_LOCATION.NNLOCATION_ID, 0) = NVL(RDNNLOC.ID, 0) ) > 0 THEN 'Y' ELSE 'N' END) AS RD_CONTRACT_BERTH_SAME_LOC,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.EMAIL ELSE K.EMAIL END) AS EMAIL,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.TELEFON ELSE K.TELEFON_1 END) AS TELEFON,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN NULL ELSE K.TELEX END) AS TELEX,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.VISINA ELSE P.VISINA END) AS VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.NTIP ELSE P.NTIP END) AS NTIP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.OPIS ELSE NT.OPIS END) AS TIP_PLOVILA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.NNTIP_TYPE ELSE NT.NNTIP_TYPE END) AS NNTIP_TYPE,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.DOLZINA ELSE NT.DOLZINA END) AS NNTIP_DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SIRINA ELSE NT.SIRINA END) AS NNTIP_SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.VISINA ELSE NT.VISINA END) AS NNTIP_VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.REGISTRSKA_N END) AS REGISTRSKA_N,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.NZASTAVA END) AS NZASTAVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE ND.OPIS END) AS NZASTAVA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.BARVA ELSE NT.BARVA END) AS BARVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_TOP ELSE NT.SVG_OBLIKA_TOP END) AS SVG_OBLIKA_TOP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_FRONT ELSE NT.SVG_OBLIKA_FRONT END) AS SVG_OBLIKA_FRONT,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.PROIZVAJALEC END) AS PROIZVAJALEC,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.BOOKING END) AS BOOKING
FROM REZERVAC R
JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC
LEFT OUTER JOIN NNPRIVEZ RDNP ON D.ID_PRIVEZ=RDNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ RNP ON R.ID_PRIVEZ=RNP.ID_PRIVEZ
LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNTIP NTR ON NTR.SIFRA = R.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = RDNP.OBJEKT
LEFT OUTER JOIN M_POGODBE MP ON MP.ID_POGODBE = R.ID_POGODBE
LEFT OUTER JOIN NNPRIVEZ POGNP ON MP.ID_PRIVEZ=POGNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = D.ID_PRIVEZ
LEFT OUTER JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC = R.ID
LEFT OUTER JOIN NNPOMOL RNPOM ON RNPOM.SIFRA = RNP.KATEGORIJA
LEFT OUTER JOIN NNLOCATION RNNLOC ON RNNLOC.ID = RNPOM.NNLOCATION_ID
LEFT OUTER JOIN NNPOMOL RDNPOM ON RDNPOM.SIFRA = RDNP.KATEGORIJA
LEFT OUTER JOIN NNLOCATION RDNNLOC ON RDNNLOC.ID = RDNPOM.NNLOCATION_ID
LEFT OUTER JOIN REZERVAC_PERIOD_DETAIL RPD ON RPD.ID_REZERVAC = R.ID
LEFT OUTER JOIN NVRSTA_REZERVAC RVR ON RVR.CODE = R.VRSTA
WHERE R.STATUS_REZERVAC >= 0 AND R.DATUM_DO IS NOT NULL
UNION ALL
SELECT R.ID AS ID_REZERVAC, -D.ID_REZERVAC_DETAIL, R.ID_POGODBE, D.DATUM_DO AS RD_DATE_FROM, TRUNC(SYSDATE) + 1 AS RD_DATE_TO, D.TIME_FROM AS RD_TIME_FROM, D.TIME_TO AS RD_TIME_TO,
RDNP.OBJEKT AS RD_OBJEKT, RDNP.N_PRIVEZA AS RD_N_PRIVEZA, RDNP.ID_PRIVEZ AS RD_ID_PRIVEZ, RDNP.NAME_PLACING AS RD_NAME_PLACING, RDNP.BOAT_GROUP_PLACING AS RD_BOAT_GROUP_PLACING, RDNP.BOAT_PLACING AS RD_BOAT_PLACING, RDNP.OCCUPANCY_STATISTICS AS RD_OCCUPANCY_STATISTICS,
R.VRSTA, -10 AS RD_STATUS_REZERVAC, D.COMPLETE AS RD_COMPLETE, D.VRSTA AS RD_VRSTA, R.ID_LASTNIKA, R.ID_PLOVILA, R.OWNER_NOTIFIED,
R.DATUM_KREIRANJA AS R_DATUM_KREIRANJA, R.USER_KREIRANJA AS R_USER_KREIRANJA, R.DATUM_SPREMEMBE AS R_DATUM_SPREMEMBE, R.USER_SPREMEMBE AS R_USER_SPREMEMBE,
NNO.OBJECT_TYPE, NNO.OBLIKA AS NNOBJEKT_OBLIKA, NNO.CENTER_POZICIJA_PLOVILA AS CENTER_POZICIJA_PLOVILA, POGNP.OBJEKT AS POGODBA_OBJEKT, POGNP.N_PRIVEZA AS POGODBA_N_PRIVEZA, 
R.DATUM_REZERVACIJE AS R_DATE_FROM, R.DATUM_DO AS R_DATE_TO, R.TIME_FROM AS R_TIME_FROM, R.TIME_TO AS R_TIME_TO,
RNP.OBJEKT AS R_OBJEKT, RNP.N_PRIVEZA AS R_N_PRIVEZA, RNP.ID_PRIVEZ AS R_ID_PRIVEZ, R.STATUS_REZERVAC AS R_STATUS_REZERVAC,
NS.DOLZINA AS DOLZINA_PRIVEZA, NS.SIRINA AS SIRINA_PRIVEZA, NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA,
(CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.TRANS_X END) AS TRANS_X_PLOVILA, (CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.TRANS_Y END) AS TRANS_Y_PLOVILA, (CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.ROT_DEGREES END) AS ROT_DEGREES_PLOVILA, 
R.KOMENTAR, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.INT_CODE AS KUPCI_INT_CODE, RNNLOC.ID AS R_ID_LOCATION, RDNNLOC.ID AS RD_ID_LOCATION,
(SELECT COUNT(*) FROM M_DE_NA WHERE ID_PLOVILA = R.ID_PLOVILA AND (NNLOCATION_ID IS NULL OR NNLOCATION_ID = RDNNLOC.ID) AND UPPER(STATUS) = 'O') AS BOAT_OPEN_WO_NUMBER, 
(SELECT COUNT(*) FROM M_STORITVE WHERE ID_PLOVILA = R.ID_PLOVILA AND (NNLOCATION_ID IS NULL OR NNLOCATION_ID = RDNNLOC.ID) AND UPPER(VRSTA) IN ('PO', 'ST') AND N_RACUNA IS NULL) AS BOAT_OPEN_SERVICES_NUMBER,
RPD.ID_REZERVAC_PERIOD AS ID_REZERVAC_PERIOD, NULL,
(CASE WHEN (SELECT COUNT(ID_CONTRACT_BERTH) FROM CONTRACT_BERTH CB WHERE CB.ID_POGODBE = R.ID_POGODBE AND CB.ID_PRIVEZ = D.ID_PRIVEZ) > 0 THEN 'Y' ELSE 'N' END) AS RD_CONTRACT_BERTH,
(CASE WHEN (SELECT COUNT(ID_CONTRACT_BERTH) FROM CONTRACT_BERTH CB LEFT OUTER JOIN V_PRIVEZ_LOCATION PRIV_LOCATION ON CB.ID_PRIVEZ = PRIV_LOCATION.ID_PRIVEZ WHERE CB.ID_POGODBE = R.ID_POGODBE AND NVL(PRIV_LOCATION.NNLOCATION_ID, 0) = NVL(RDNNLOC.ID, 0) ) > 0 THEN 'Y' ELSE 'N' END) AS RD_CONTRACT_BERTH_SAME_LOC,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.EMAIL ELSE K.EMAIL END) AS EMAIL,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.TELEFON ELSE K.TELEFON_1 END) AS TELEFON,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN NULL ELSE K.TELEX END) AS TELEX,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.VISINA ELSE P.VISINA END) AS VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.NTIP ELSE P.NTIP END) AS NTIP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.OPIS ELSE NT.OPIS END) AS TIP_PLOVILA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.NNTIP_TYPE ELSE NT.NNTIP_TYPE END) AS NNTIP_TYPE,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.DOLZINA ELSE NT.DOLZINA END) AS NNTIP_DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SIRINA ELSE NT.SIRINA END) AS NNTIP_SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.VISINA ELSE NT.VISINA END) AS NNTIP_VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.REGISTRSKA_N END) AS REGISTRSKA_N,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.NZASTAVA END) AS NZASTAVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE ND.OPIS END) AS NZASTAVA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.BARVA ELSE NT.BARVA END) AS BARVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_TOP ELSE NT.SVG_OBLIKA_TOP END) AS SVG_OBLIKA_TOP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_FRONT ELSE NT.SVG_OBLIKA_FRONT END) AS SVG_OBLIKA_FRONT,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.PROIZVAJALEC END) AS PROIZVAJALEC,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.BOOKING END) AS BOOKING
FROM REZERVAC R
JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC
LEFT OUTER JOIN NNPRIVEZ RDNP ON D.ID_PRIVEZ=RDNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ RNP ON R.ID_PRIVEZ=RNP.ID_PRIVEZ
LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNTIP NTR ON NTR.SIFRA = R.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = RDNP.OBJEKT
LEFT OUTER JOIN M_POGODBE MP ON MP.ID_POGODBE = R.ID_POGODBE
LEFT OUTER JOIN NNPRIVEZ POGNP ON MP.ID_PRIVEZ=POGNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = D.ID_PRIVEZ
LEFT OUTER JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC = R.ID
LEFT OUTER JOIN NNPOMOL RNPOM ON RNPOM.SIFRA = RNP.KATEGORIJA
LEFT OUTER JOIN NNLOCATION RNNLOC ON RNNLOC.ID = RNPOM.NNLOCATION_ID
LEFT OUTER JOIN NNPOMOL RDNPOM ON RDNPOM.SIFRA = RDNP.KATEGORIJA
LEFT OUTER JOIN NNLOCATION RDNNLOC ON RDNNLOC.ID = RDNPOM.NNLOCATION_ID
LEFT OUTER JOIN REZERVAC_PERIOD_DETAIL RPD ON RPD.ID_REZERVAC = R.ID
WHERE R.DATUM_DO IS NOT NULL AND R.STATUS_REZERVAC = 1 AND D.DATUM_DO <= TRUNC(SYSDATE) AND D.ID_REZERVAC_DETAIL IN 
(SELECT ID_REZERVAC_DETAIL FROM REZERVAC_DETAIL WHERE DATUM_DO = (SELECT MAX(D2.DATUM_DO) FROM REZERVAC_DETAIL D2 WHERE D2.STATUS_REZERVAC = 1 AND D2.COMPLETE = 'Y' AND D2.ID_REZERVAC = R.ID))
);

DROP VIEW V_RESERVATIONS_MANAGEMENT;

CREATE OR REPLACE VIEW V_RESERVATIONS_MANAGEMENT AS 
(
SELECT 'ALARM_ARRIVAL' AS CATEGORY, CONCAT('ALARM_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) < TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2 AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE < RE.DATUM_REZERVACIJE AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC IN (1,2) )
UNION ALL
SELECT 'ALARM_DEPARTURE' AS CATEGORY, CONCAT('ALARM_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_DO) <= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC IN (1,2) AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)
UNION ALL
SELECT 'ALARM_MOVE' AS CATEGORY, CONCAT('ALARM_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD <= TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'ALARM_EXIT' AS CATEGORY, CONCAT('ALARM_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'ALARM_RETURN' AS CATEGORY, CONCAT('ALARM_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 2 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'PLAN_ARRIVAL' AS CATEGORY, CONCAT('PLAN_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) >= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2
UNION ALL
SELECT 'PLAN_DEPARTURE' AS CATEGORY, CONCAT('PLAN_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_DO) >= TRUNC(SYSDATE) AND (RE.STATUS_REZERVAC IN (1, 2) OR (RE.STATUS_REZERVAC IN (3, 4) AND RE.VRSTA = 'RE')) AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)
AND RE.DATUM_DO = (SELECT MAX(DE2.DATUM_DO) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = DE.ID_REZERVAC AND DE2.ID_PRIVEZ = DE.ID_PRIVEZ AND DE2.STATUS_REZERVAC = DE.STATUS_REZERVAC)
UNION ALL
SELECT 'PLAN_MOVE' AS CATEGORY, CONCAT('PLAN_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND NOT EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)
UNION ALL
SELECT 'PLAN_EXIT' AS CATEGORY, CONCAT('PLAN_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N')
UNION ALL
SELECT 'PLAN_RETURN' AS CATEGORY, CONCAT('PLAN_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)
UNION ALL
SELECT 'CURRENT_PRESENT' AS CATEGORY, CONCAT('CURRENT_PRESENT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE = 'Y')
UNION ALL
SELECT 'CURRENT_EXIT' AS CATEGORY, CONCAT('CURRENT_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO,
VD.N_PRIVEZA, VD.ID_PRIVEZ, VD.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
LEFT OUTER JOIN (SELECT ID, N_PRIVEZA, ID_PRIVEZ, NNLOCATION_ID, ID_LASTNIKA, ID_PLOVILA, KATEGORIJA_DOGODKA, ROW_NUMBER() OVER (PARTITION BY ID_LASTNIKA, ID_PLOVILA, KATEGORIJA_DOGODKA ORDER BY ID DESC) RNK FROM V_DOGODKI) VD
ON (VD.ID_LASTNIKA = RE.ID_LASTNIKA AND VD.ID_PLOVILA = RE.ID_PLOVILA AND VD.RNK = 1 AND VD.KATEGORIJA_DOGODKA = 'IZ')
WHERE RE.STATUS_REZERVAC = 2 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE = 'Y')
)
;

DROP VIEW V_KUPCI_PLOVILA;

CREATE OR REPLACE VIEW V_KUPCI_PLOVILA AS (
  SELECT CONCAT(CONCAT(K.ID, '-'), P.ID) AS KUPCI_PLOVILA_ID, K.ID AS ID_LASTNIKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.VRSTA AS KUPCI_VRSTA,
  K.NDRZAVA AS KUPCI_NDRZAVA, K.EMAIL AS KUPCI_EMAIL, K.TELEFON_1 AS KUPCI_TELEFON_1, K.YACHT_CLUB_ID, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.ACT AS KUPCI_ACT, K.TELEX AS KUPCI_TELEX, K.GSM AS KUPCI_GSM, K.TELEFON_2 AS KUPCI_TELEFON_2, 
  K.DAVCNA_STEVILKA AS KUPCI_DAVCNA_STEVILKA, K.VALUTA_PLACILA AS KUPCI_VALUTA_PLACILA, K.SALDAKONTI_SIT AS KUPCI_SALDAKONTI_SIT, K.SALDAKONTI_DEM AS KUPCI_SALDAKONTI_DEM, K.SALDAKONTI_KOM AS KUPCI_SALDAKONTI_KOM, K.INT_CODE AS KUPCI_INT_CODE,
  K.VEHICLE_REGISTRATION_NUM AS KUPCI_VEHICLE_REGISTRATION_NUM, K.MANAGER AS KUPCI_MANAGER, K.N_DOKUMENTA AS KUPCI_N_DOKUMENTA,
 (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, P.REGISTRSKA_N AS PLOVILA_REGISTRSKA_N, P.MODEL AS PLOVILA_MODEL, P.NTIP AS PLOVILA_NTIP, P.NZASTAVA AS PLOVILA_NZASTAVA, P.TRENUTNO_DO, P.POGODBA_DO, P.DOLZINA AS PLOVILA_DOLZINA, 
  P.SIRINA AS PLOVILA_SIRINA, P.GREZ AS PLOVILA_GREZ, P.BOOKING AS PLOVILA_BOOKING, P.ACT AS PLOVILA_ACT,
  CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.OBJEKT ELSE P.TRENUTNI_OBJEKT_PRIVEZA END AS TRENUTNI_OBJEKT_PRIVEZA,
  CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.N_PRIVEZA ELSE P.TRENUTNA_N_PRIVEZA END AS TRENUTNA_N_PRIVEZA, BERTH_TEMP.KATEGORIJA AS TRENUTNA_KATEGORIJA,
  CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.OBJEKT ELSE P.POGODBENI_OBJEKT_PRIVEZA END AS POGODBENI_OBJEKT_PRIVEZA,
  CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.N_PRIVEZA ELSE P.POGODBENA_N_PRIVEZA END AS POGODBENA_N_PRIVEZA, BERTH_CONTRACT.KATEGORIJA AS POGODBENA_KATEGORIJA,
  NNUSR.USER_ AS KUPCI_MANAGER_USER, VPT.ID_PRIVEZ AS ID_PRIVEZ_TEMP, VPT.NNLOCATION_ID AS ID_LOCATION_TEMP, VPC.ID_PRIVEZ AS ID_PRIVEZ_CONTRACT, VPC.NNLOCATION_ID AS ID_LOCATION_CONTRACT
  FROM KUPCI K
  LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA = K.ID
  LEFT OUTER JOIN NUSER NNUSR ON K.MANAGER = NNUSR.NUSER
  LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI ASC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NULL) PRIVEZI_TEMP ON (PRIVEZI_TEMP.ID_PLOVILA = P.ID AND PRIVEZI_TEMP.RNK = 1)
  LEFT OUTER JOIN NNPRIVEZ BERTH_TEMP ON BERTH_TEMP.ID_PRIVEZ = PRIVEZI_TEMP.ID_PRIVEZ
  LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI DESC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NOT NULL) PRIVEZI_CONTRACT ON (PRIVEZI_CONTRACT.ID_PLOVILA = P.ID AND PRIVEZI_CONTRACT.RNK = 1)
  LEFT OUTER JOIN NNPRIVEZ BERTH_CONTRACT ON BERTH_CONTRACT.ID_PRIVEZ = PRIVEZI_CONTRACT.ID_PRIVEZ
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPT ON VPT.ID_PRIVEZ = BERTH_TEMP.ID_PRIVEZ
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPC ON VPC.ID_PRIVEZ = BERTH_CONTRACT.ID_PRIVEZ
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1591, SYSDATE, '5.5', 1511, 'Rezervac time')
;