ALTER TABLE DATOTEKE_KUPCEV
ADD NNLOCATION_ID NUMBER;

ALTER TABLE DATOTEKE_PLOVIL
ADD NNLOCATION_ID NUMBER;

UPDATE DATOTEKE_KUPCEV D
SET D.NNLOCATION_ID = (SELECT M.NNLOCATION_ID FROM M_POGODBE M WHERE M.ID_POGODBE = D.ID_POGODBE)
WHERE D.ID_POGODBE IS NOT NULL AND D.NNLOCATION_ID IS NULL;

UPDATE DATOTEKE_KUPCEV D
SET D.NNLOCATION_ID = (SELECT M.NNLOCATION_ID FROM M_DE_NA M WHERE M.ID_DN = D.ID_DN)
WHERE D.ID_DN IS NOT NULL AND D.NNLOCATION_ID IS NULL;

UPDATE DATOTEKE_KUPCEV D
SET D.NNLOCATION_ID = (SELECT M.NNLOCATION_ID FROM M_STORITVE M WHERE M.ID_STORITVE = D.ID_STORITVE)
WHERE D.ID_STORITVE IS NOT NULL AND D.NNLOCATION_ID IS NULL;

DROP VIEW V_DATOTEKE_KUPCEV;

CREATE OR REPLACE VIEW V_DATOTEKE_KUPCEV AS (
SELECT D.ID_DATOTEKE_KUPCEV, D.ID_KUPCA, D.VRSTA, D.DATOTEKA, D.IME_DATOTEKE, D.KONCNICA, D.KOMENTAR, D.USER_KREIRANJA, D.DATUM_KREIRANJA, 
D.USER_SPREMEMBE, D.DATUM_SPREMEMBE, D.STATUS, D.VALID, D.FILE_REFERENCE, D.ID_POGODBE, D.ISSUE_DATE, D.ID_DN, D.ID_STORITVE, D.NNLOCATION_ID,
N.OPIS AS VRSTA_OPIS, N.INTERNI_OPIS AS VRSTA_INTERNI_OPIS, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM DATOTEKE_KUPCEV D
LEFT OUTER JOIN NNDATOTEKE_KUPCEV_VRSTA N ON N.SIFRA = D.VRSTA
LEFT OUTER JOIN KUPCI K ON K.ID = D.ID_KUPCA
);

DROP VIEW V_DATOTEKE_PLOVIL;

CREATE OR REPLACE VIEW V_DATOTEKE_PLOVIL AS (
SELECT D.ID_DATOTEKE_PLOVIL, D.ZAPOREDNA, D.ID, D.DOKUMENT, D.DATOTEKA, D.TIP, D.GRUPA, D.VALID,
D.KOMENTAR, D.AVTOR, D.DATUM, D.USER_KREIRANJA, D.DATUM_KREIRANJA, D.USER_SPREMEMBE, D.DATUM_SPREMEMBE, D.STATUS, D.FILE_REFERENCE, D.NNLOCATION_ID,
N.OPIS AS NNSTOFILTER_OPIS, P.IME AS PLOVILA_IME,
NT.SIFRA AS NNTIPPRILOGE_SIFRA, NT.OPIS AS NNTIPPRILOGE_OPIS, D.DOCUMENTTYPE, D.ISSUER, D.DATEISSUE, CASE WHEN EXISTS (SELECT 1 FROM DATOTEKE_PLOVIL D2 WHERE D2.ID = D.ID AND D.ZAPOREDNA =
(SELECT MAX(D3.ZAPOREDNA) FROM DATOTEKE_PLOVIL D3 WHERE D3.ID = D.ID AND D3.DOCUMENTTYPE = D.DOCUMENTTYPE)) THEN 'Y' ELSE 'N' END AS LATEST_BY_DOCUMENTTYPE
FROM DATOTEKE_PLOVIL D
LEFT OUTER JOIN NNSTOFILTER N ON N.ID = D.GRUPA
LEFT OUTER JOIN NNTIPPRILOGE NT ON NT.SIFRA = D.DOCUMENTTYPE
LEFT OUTER JOIN PLOVILA P ON P.ID = D.ID
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1918, SYSDATE, '5.5', 1838, 'Files location')
;
