DROP VIEW V_NCARD;

CREATE OR REPLACE VIEW V_NCARD AS (
SELECT N.NCARD, N.ID_LASTNIKA, N.ID_PLOVILA, N.VELJA_OD, N.VELJA_DO, N.SERIALNUMBER, N.NCARD_TYPE, N."COMMENT", N.STATUS, N.NNLOCATION_ID, N.RETURNED,
NCT.OPIS AS NCARD_TYPE_OPIS, NCT.INTERNI_OPIS AS NCARD_TYPE_INTERNI_OPIS, P.IME AS PLOVILA_IME, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
(SELECT S.N_RACUNA FROM SALDKONT S WHERE S.NCARD = N.NCARD AND S.VRSTA_RACUNA IN ('POS', 'RAC') AND S.STORNO IS NULL AND ROWNUM <= 1) AS INVOICE_NUMBER,
(SELECT SUM(S.ZA_PLACILO) FROM SALDKONT S WHERE S.NCARD = N.NCARD AND S.VRSTA_RACUNA IN ('POS', 'RAC') AND (S.STORNO IS NULL OR S.STORNO <> 'D')) AS INVOICE_VALUE,
(SELECT SUM(S.ZA_PLACILO-S.PORABLJENO) FROM SALDKONT S WHERE S.NCARD = N.NCARD AND S.VRSTA_RACUNA IN (SELECT NK.SALDKONT FROM NKNJIZBA NK WHERE NK.DEPOSIT = 'Y')) AS DEPOSIT_VALUE,
(SELECT SUM(ABS(S.ZA_PLACILO)) FROM SALDKONT S WHERE S.NCARD = N.NCARD AND S.VRSTA_RACUNA IN (SELECT NK.SALDKONT FROM NKNJIZBA NK WHERE NK.REFUND = 'Y')) AS REFUND_VALUE
FROM NCARD N
LEFT OUTER JOIN NCARD_TYPE NCT ON NCT.ID = N.NCARD_TYPE
LEFT OUTER JOIN KUPCI K ON K.ID = N.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = N.ID_PLOVILA
);

DROP VIEW V_WAITLIST;

CREATE OR REPLACE VIEW V_WAITLIST AS (
SELECT W.ID_WAITLIST, W.NNLOCATION_ID, W.ID_LASTNIKA, W.ID_PLOVILA, W.ID_TYPE, W.AREA, W.ID_PRIVEZ, W.DATE_FROM, W.DATE_TO, W.LENGTH_OF_STAY, W.STATUS, W.DATE_CREATED, W.USER_CREATED, W.DATE_CHANGED, W.USER_CHANGED, W.USER_COMMENT,
WT.DESCRIPTION AS TYPE_DESCRIPTION, P.IME AS BOAT_NAME, NT.OPIS AS BOAT_TYPE, P.DOLZINA AS BOAT_LENGTH, P.SIRINA AS BOAT_WIDTH, P.GREZ AS BOAT_DRAUGHT, W.BERTH_LENGTH_DESC, NO.OPIS AS AREA_DESCRIPTION, NP.N_PRIVEZA AS BERTH_DESCRIPTION,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER, 
VK.OPIS AS OWNER_TYPE_DESCRIPTION, W.OWNER_TYPE AS OWNER_TYPE, VS.OPIS AS OWNER_SUBTYPE_DESCRIPTION, K.SUBTYPE AS OWNER_SUBTYPE, K.TELEX AS OWNER_MOBILE_PHONE
FROM WAITLIST W
LEFT OUTER JOIN WAITLIST_TYPE WT ON WT.ID_WAITLIST_TYPE = W.ID_TYPE
LEFT OUTER JOIN PLOVILA P ON P.ID = W.ID_PLOVILA
LEFT OUTER JOIN KUPCI K ON K.ID = W.ID_LASTNIKA
LEFT OUTER JOIN NNOBJEKT NO ON NO.SIFRA = W.AREA
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = W.ID_PRIVEZ 
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNVRSKUP VK ON VK.SIFRA = W.OWNER_TYPE
LEFT OUTER JOIN NNVRSKUP VS ON VS.SIFRA = K.SUBTYPE
);

INSERT INTO NKUPCIBELEZKE_TYPE (ID, OPIS, INTERNI_OPIS, ACT)
VALUES (1, 'Reservation', 'Reservation', 'Y');

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2008, SYSDATE, '5.5', 1928, 'Card and waitlist')
;
